%global with_gcj %{!?_without_gcj:1}%{?_without_gcj:0}

Name:           jjack
Version:        0.3
Release:        2%{?dist}
Summary:        JACK audio driver for the Java Sound API
Group:          System Environment/Libraries
License:        LGPLv2+
URL:            http://jjack.berlios.de/
# The original source file is 
# http://download.berlios.de/%{name}/%{name}-%{version}.tar.gz
# We re-encoded the MP3 files in the tarball in OGG format to produce
Source0:        %{name}-%{version}-FE.tar.gz
# Shell script to run the JJack Shell Application. Derived from the bin/jjack.sh
# script in the tarball
Source1:        %{name}.sh
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  jack-audio-connection-kit-devel
BuildRequires:  java-devel >= 1.5
BuildRequires:  ant
BuildRequires:  jpackage-utils
%if %{with_gcj}
BuildRequires:  java-gcj-compat-devel >= 1.0.31
Requires(post):   java-gcj-compat >= 1.0.31
Requires(postun): java-gcj-compat >= 1.0.31
%endif
Requires:       jpackage-utils
Requires:       java >= 1.5


%description
JJack is a JACK audio driver for the Java Sound API  and a framework for the
Java programming language  that allows Java applications to use the JACK Audio
Connection Kit. Audio processor clients can be designed to:

  * create their own sounds (as a synthesizer or sample-player)
  * change the sound-output of other clients (e.g. as an effects-device)
  * analyse the audio streams generated by other clients (e.g. display 
    the wave form)

%package javadoc
Summary:        Javadocs for %{name}
Group:          Documentation
Requires:       %{name} = %{version}-%{release}
Requires:       jpackage-utils

%description javadoc
This package contains the API documentation for %{name}.

%prep
%setup -q

# Remove percompiled binaries
for ext in class jar jnilib o so; do
   find -name "*.$ext" -exec rm -f '{}' \;
done

# Ugly hack to impose optflags
for flag in $RPM_OPT_FLAGS; do
   ANT_GCC_FLAGS+="<arg value=\"$flag\"/>\n      "
done
sed -i "s|\(<arg value=\"-fPIC\"/>\)|\1\n      $ANT_GCC_FLAGS|" make/build.xml

# We don't want do deal with complications during %%install
sed -i 's|/\${os.arch}/\${os.name}||' make/build.xml

# To dlopen the library correctly
sed -i 's|File(.*|File("%{_libdir}/%{name}/lib%{name}.so");|' \
   src/de/gulden/framework/jjack/JJackSystem.java

# We replace mp3 with ogg
for file in doc/www/examples.html README; do
   sed -i 's|mp3|ogg|g' $file
done

# Fix encoding
iconv -f iso8859-1 -t utf8 CHANGELOG -o tmpfile
touch -r CHANGELOG tmpfile
mv -f tmpfile CHANGELOG

%build
pushd make
   %ant -v all
popd

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_libdir}/%{name}

# jar files
pushd lib
   for jarfile in %{name}*.jar; do
      jarname=${jarfile%.*}
      install -pm 644 $jarfile \
              $RPM_BUILD_ROOT%{_libdir}/%{name}/$jarname-%{version}.jar
      ln -s $jarname-%{version}.jar $RPM_BUILD_ROOT%{_libdir}/%{name}/$jarfile
   done
# native lib
   install -pm 755 lib%{name}.so $RPM_BUILD_ROOT%{_libdir}/%{name}/
popd

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}
cp -rp doc/*  \
   $RPM_BUILD_ROOT%{_javadocdir}/%{name}/

# the wrapper script
mkdir -p $RPM_BUILD_ROOT%{_bindir}
install -pm 755 %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/%{name}

# aot bits
%if %{with_gcj}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%if %{with_gcj}
if [ -x %{_bindir}/rebuild-gcj-db ] 
then
%{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%if %{with_gcj}
if [ -x %{_bindir}/rebuild-gcj-db ] 
then
%{_bindir}/rebuild-gcj-db
fi
%endif


%files
%defattr(-,root,root,-)
%doc CHANGELOG LICENSE README
%{_libdir}/%{name}/
%{_bindir}/%{name}

%if %{with_gcj}
%{_libdir}/gcj/%{name}
%endif

%files javadoc
%defattr(-,root,root,-)
%{_javadocdir}/%{name}


%changelog
* Sun Apr 26 2009 Orcan Ogetbil <oget [DOT] fedora [AT] gmail [DOT] com> - 0.3-2
- Minor update on the wrapper script

* Sun Mar 22 2009 Orcan Ogetbil <oget [DOT] fedora [AT] gmail [DOT] com> - 0.3-1
- Initial build
